/*                                                                |- Impulse -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is the Impulse utility library
 * for Impulse. (Part of the ROWS distribution)
 *
 * The Initial Developer of the Original Code is
 * Daniel Berrange. Portions created by Daniel Berrange
 * are Copyright (C) 1999 Daniel Berrange.
 * All Rights Reserved
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * message.h
 * ---------
 *
 * Communication transport functions
 */


#ifndef __impulse_comms_message_h
#define __impulse_comms_message_h


#include <impulse/util/setup.h>

struct _impulse_message_header
{
  impulse_ushort service;
  impulse_ushort opcode;
  impulse_ushort length;
  impulse_ushort pad;
};

typedef struct _impulse_message_header *impulse_message_header;

struct _impulse_message
{
  impulse_ushort service;
  impulse_ushort opcode;

  impulse_message_header header;
  impulse_ushort header_length;
  
  impulse_ubyte *body;
  impulse_ushort body_length;
  
  void *data;
  impulse_ushort data_length;
};

typedef struct _impulse_message *impulse_message;


impulse_message impulse_message_create(impulse_ushort service,
				       impulse_ushort opcode,
				       impulse_ushort length);
impulse_message impulse_message_create_header(impulse_message_header header);
void impulse_message_destroy(impulse_message msg);

#endif

/* End of file */

