/*                                                                |- Impulse -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is the Impulse utility library
 * for Impulse. (Part of the ROWS distribution)
 *
 * The Initial Developer of the Original Code is
 * Daniel Berrange. Portions created by Daniel Berrange
 * are Copyright (C) 1999 Daniel Berrange.
 * All Rights Reserved
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * transport_int.h
 * ---------------
 *
 * Communication transport protocol
 */


#ifndef __impulse_comms_transport_int_h
#define __impulse_comms_transport_int_h

#include <impulse/comms/transport.h>

/*                            ======--------======                           */

/* 
 * Fix me: define generic error return values
 */

struct _impulse_transport_funcs
{
  /* Creation stuff */
  void *(*create)(void);
  void (*destroy)(void *);

  /* Event handling stuff */
  impulse_int (*handle)(void *,
			impulse_transport_handler,
			void *);
  impulse_int (*unhandle)(void *);
  
  /* Connection management */
  impulse_int (*open)(void *,
		      impulse_unistring,
		      impulse_unistring,
		      impulse_int);
  impulse_int (*accept)(void *,
			void **);
  impulse_int (*close)(void *);
  impulse_int (*active)(void *);

  /* void * transfer stuff */
  impulse_int (*pending)(void *);
  impulse_int (*send)(void *,
		      impulse_byte *,
		      impulse_uint,
		      impulse_unistring address);
  impulse_int (*receive)(void *,
			 impulse_byte *,
			 impulse_uint,
			 impulse_unistring *);
  impulse_int (*peek)(void *,
		      impulse_byte *,
		      impulse_uint,
		      impulse_unistring *);

  /* Address stuff */
  impulse_int (*local)(void *,
		       impulse_unistring *);
  impulse_int (*remote)(void *,
			impulse_unistring *);
};


#endif

/* End of file */
