/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * style.h
 * -------
 *
 * A drawing style
 */

#ifndef __impulse_rows_style_h
#define __impulse_rows_style_h

#include <impulse/rows/colour.h>

/*                            ======--------======                           */

typedef struct _ROWS_style *ROWS_style;

/*                            ======--------======                           */

#include <impulse/rows/brush.h>

/*                            ======--------======                           */

/* Activation types */

typedef enum {
  ROWS_STYLE_NORMAL,
  ROWS_STYLE_INACTIVE,
  ROWS_STYLE_HIGHLIGHT,
  ROWS_STYLE_FOCUS,
  ROWS_STYLE_ACTIVE,

  ROWS_STYLE_MAX_ACTIVE
} ROWS_style_active_type;

typedef enum {
  ROWS_STYLE_BACKGROUND = 0,
  ROWS_STYLE_FOREGROUND,
  ROWS_STYLE_WRITABLE_BACK,
  ROWS_STYLE_BORDERSHADOW,
  ROWS_STYLE_BORDERHILITE,

  ROWS_STYLE_MAX_BRUSH
} ROWS_style_brush_type;

/*                            ======--------======                           */

/* Type definitions */

struct _ROWS_style_brush {
  ROWS_brush  brush;
  ROWS_colour fg_colour;
  ROWS_colour bg_colour;
};

struct _ROWS_style {
  struct _ROWS_style_brush *brushes;
  int    nbrushes;

  ROWS_brush brush[ROWS_STYLE_MAX_ACTIVE][ROWS_STYLE_MAX_BRUSH];

  int usage;
};

/*                            ======--------======                           */

/* Functions */

extern ROWS_style ROWS_style_create(ROWS_drawable drawable);
extern void ROWS_style_reference(ROWS_style style);
extern void ROWS_style_dereference(ROWS_style style);
extern void ROWS_style_destroy(ROWS_style style);

#endif
